## date calculator
## for perl on windows
##   
##       ver2.00: on 2022/4/22
##  Coded by ceder
##
##



use strict;
use warnings;
use utf8;
use v5.14;

use lib '.\datelib';
use Date;
use Dateutil;

########################
# subroutine           #
########################

sub getdate {
 my $exp=shift;
 if(my $date=Date->new($exp) ) {
   return $date;
  } else {
  print "invalid date\n";
  return undef;
 };
}

########################
# main                 #
########################


print "?";

my $y="([0-9]{4})|([MmTtSsHhRr][0-9]+)";
my $ym="($y)/[0-9]{1,2}";
my $ymd="($y)/[0-9]{1,2}/[0-9]{1,2}";

while(<>) {
 {
  s/^\s+//;
  s/\s+$//;

  if ( m%\A($y)\z% ) {
    next unless my $date=getdate($_);
    $date->convertYear;
    print $date->printDate,"\n";
     } 
   elsif (m%\A($y)\s*\+\s*([0-9]+)\z% ){
     next unless my $date=getdate($1);
     $date->afterYears($4);
     print $date->printDate,"\n";
      } 
   elsif (m%\A($y)\s*=\+\s*([0-9]+)\z% ){
     next unless my $date=getdate($1);
     $date->afterYears($4,1);
     print $date->printDate,"\n";
      } 
   elsif (m%\A($y)\s*-\s*([0-9]+)\z% ){
     next unless my $date=getdate($1);
     $date->beforeYears($4);
     print $date->printDate,"\n";
      } 
   elsif (m%\A($y)\s*=-\s*([0-9]+)\z% ){
     next unless my $date=getdate($1);
     $date->beforeYears($4,1);
     print $date->printDate,"\n";
      } 
   elsif ( m%\A($y)\s*to\s*($y)\z% ) {
     next unless my $date1=getdate($1);
     next unless my $date2=getdate($4);
     my $m=countYear($date1,$date2);
     print $m,"\n";
      }
   elsif ( m%\A($ym)\s*to\s*($ym)\z% ) {
     next unless my $date1=getdate($1);
     next unless my $date2=getdate($5);
     my $m=countMonth($date1,$date2);
     print $m,"\n";
      }
   elsif ( m%\A($ymd)\s*to\s*($ymd)\z% ) {
     next unless my $date1=getdate($1);
     next unless my $date2=getdate($5);
     my $m=countDay($date1,$date2);
     print $m,"\n";
      }
   elsif (m%\A($ym)\s*\+\s*([0-9]+)\z% ){
     next unless my $date=getdate($1);
     $date->afterMonths($5);
     print $date->printDate,"\n";
      } 
   elsif (m%\A($ym)\s*=\+\s*([0-9]+)\z% ){
     next unless my $date=getdate($1);
     $date->afterMonths($5,1);
     print $date->printDate,"\n";
      }
   elsif (m%\A($ym)\s*-\s*([0-9]+)\z% ){
     next unless my $date=getdate($1);
     $date->beforeMonths($5);
     print $date->printDate,"\n";
      } 
   elsif (m%\A($ym)\s*=-\s*([0-9]+)\z% ){
     next unless my $date=getdate($1);
     $date->beforeMonths($5,1);
     print $date->printDate,"\n";
      }
   elsif (m%\A($ymd)\s*\+\s*([0-9]+)\z% ){
     next unless my $date=getdate($1);
     $date->afterDays($5);
     print $date->printDate,"\n";
      } 
   elsif (m%\A($ymd)\s*=\+\s*([0-9]+)\z% ){
     next unless my $date=getdate($1);
     $date->afterDays($5,1);
     print $date->printDate,"\n";
      }
   elsif (m%\A($ymd)\s*-\s*([0-9]+)\z% ){
     next unless my $date=getdate($1);
     $date->beforeDays($5);
     print $date->printDate,"\n";
      } 
   elsif (m%\A($ymd)\s*=-\s*([0-9]+)\z% ){
     next unless my $date=getdate($1);
     $date->beforeDays($5,1);
     print $date->printDate,"\n";
      }
  elsif (m%\A($ymd)\s*reach\s*([0-9]+)\z% ){
     next unless my $date=getdate($1);
     $date->beforeYears($5);
     $date->afterDays;
     print "born on ",$date->printDate,"\n";
      }  
  elsif (m%\A($ymd)\s*age\s*([0-9]+)\z% ){
     next unless my $date=getdate($1);
     $date->beforeYears($5);
     $date->afterDays;
     my $date1=Date->new($date);
     $date1->beforeYears;
     $date1->afterDays;
     print "born between ",$date1->printDate," and ",$date->printDate,"\n";
      } 
   elsif ( m%\A($ymd)\s*born(\s*on)?\s*($ymd)\z% ) {
     next unless my $date2=getdate($1);
     next unless my $date1=getdate($6);
     my ($y,$m)=getAge($date1,$date2,1);
     print "age $y and $m months on $1\n";
      }
   elsif ( m%\A([0-9]+)\s*born(\s*on)?\s*($ymd)\z% ) {
     next unless my $date=getdate($3);
     $date->afterYears($1);
     $date->beforeDays;
     print "reach $1 on ",$date->printDate,"\n";
      } 
   elsif(m%help%) {
     print 'yy'."\n";
     print '$date [+|=+|-|=-] [$years|$months|$days]'." \n";
     print 'yy to yy'."\n";
     print 'yy/mm to yy/mm'."\n";
     print 'yy/mm/dd to yy/mm/dd'."\n";
     print '$date reach $age'." \n";
     print '$date age $age'." \n";
     print '$date born (on) $birthday'."\n";
     print '$age born (on) $birthday'."\n";
      }
   elsif (m%exit%) {
     exit 0;
    }
   else {
    print "illegal Expression\n";
    };
  };
 print "?";
 };

print "end\n";