###############################################
#   Date caluclator for windows               #
#     in Perl/Tk(Tkx)
###############################################
#
#      ver2.00 : 2022/5/1
#        coded by ceder
#

use strict;
use warnings;
use utf8;


use lib '.\datelib';
use Date;
use Dateutil;

use Tkx;

BEGIN{
  if ($^O eq 'MSWin32'){
    require Win32::Console;
    Win32::Console::Free();
  }
 }


my $Y="([0-9]{4})|([MmTtSsHhRr][0-9]+)";
my $YM="($Y)/[0-9]{1,2}";
my $YMD="($Y)/[0-9]{1,2}/[0-9]{1,2}";
my $NUM="[0-9]+";

my $operand1="";
my $operand2="";
my $operator="";
my $result="";




##############################################
#  Graphical Interface
##############################################
my $top=Tkx::widget->new(".");
$top->g_wm_title('Date Calulator');
$top->m_configure();
Tkx::option_add('*font',["ＭＳ ゴシック", 11]);

my $frame0=$top->new_frame();
my $op1lab=$frame0->new_label(-text=>'OP1(日,年齢)',-font=>"gothic 11 bold",-width=>16,-anchor=>'w');
$op1lab->g_pack(-side=>'left',-padx=>4,-pady=>2);
my $op2lab=$frame0->new_label(-text=>'OP2(日,数,誕生日)',-font=>"gothic 11 bold",-width=>16,-anchor=>'w');
$op2lab->g_pack(-side=>'left',-padx=>4,-pady=>2);
my $helpb=$frame0->new_button(-text=>'HELP',-width=>5,-command=>\&help);
$helpb->g_pack(-side=>'left',-padx=>4,-pady=>2);

my $frame1=$top->new_frame();
my $ent1=$frame1->new_entry(-textvariable => \$operand1,-font=>"gothic 11 bold",-width=>16);
$ent1->g_pack(-side=>"left",-padx=>4);
my $ent2=$frame1->new_entry(-textvariable => \$operand2,-font=>"gothic 11 bold",-width=>16);
$ent2->g_pack(-side=>"left",-padx=>4);
my $clear=$frame1->new_button(-text => '消去',-width=>5, -command=>\&clear);
$clear->g_pack(-side=>'left',-padx=>8);

my $frame2=$top->new_frame();
my $frame21=$frame2->new_frame();
my $rb1=$frame21->new_radiobutton(-text=>"前",-variable=>\$operator,-value=>'-',-state=>'disabled');
$rb1->g_pack(-side=>'left');
my $rb2=$frame21->new_radiobutton(-text=>"以前",-variable=>\$operator,-value=>'=-',-state=>'disabled');
$rb2->g_pack(-side=>'left');
my $rb3=$frame21->new_radiobutton(-text=>"後",-variable=>\$operator,-value=>'+',-state=>'disabled');
$rb3->g_pack(-side=>'left');
my $rb4=$frame21->new_radiobutton(-text=>"以後",-variable=>\$operator,-value=>'=+',-state=>'disabled');
$rb4->g_pack(-side=>'left');
my $frame22=$frame2->new_frame();
my $rb5=$frame22->new_radiobutton(-text=>"OP1にOP2歳に到達",-variable=>\$operator,-value=>'reach',-state=>'disabled');
$rb5->g_pack(-side=>'left');
my $rb6=$frame22->new_radiobutton(-text=>"OP1においてOP2歳である",-variable=>\$operator,-value=>'age',-state=>'disabled');
$rb6->g_pack(-side=>'left');
$frame21->g_pack(-side=>'top',-anchor=>'w');
$frame22->g_pack(-side=>'top',-anchor=>'w');

my $frame3=$top->new_frame();
my $text1=$frame3->new_label(-textvariable=>\$result,-width=>40,-background=>'white',-anchor=>'w');
$text1->g_pack(-side=>'left',-padx=>4,-pady=>2);

my $frame4=$top->new_frame();
my $calc=$frame4->new_button(-text=>'計算',-width=>10, -command=>\&calc);
$calc->g_pack(-side=>'left', -anchor=>'e',-padx=>4,-pady=>2);
my $exitb=$frame4->new_button(-text=>'終了',-width=>5, -command=>sub {g_destroy $top;});
$exitb->g_pack(-side=>'left', -anchor=>'e',-padx=>4,-pady=>2);

$frame0->g_pack(-side => 'top',-anchor=>'w');
$frame1->g_pack(-side => 'top',-anchor=>'w');
$frame2->g_pack(-side => 'top',-anchor=>'w');
$frame3->g_pack(-side => 'top',-anchor=>'w');
$frame4->g_pack(-side => 'top',-anchor=>'e');

#####################################
#  events                           #
#####################################
# $ent1 -> g_bind('<KeyPress>',\&checkrb);
# $ent2 -> g_bind('<KeyPress>',\&checkrb);

  $top -> g_bind('<KeyPress>',\&checkrb);
 
 sub checkrb {
 
   if(($operand1 !~ /\As*\z/) && ($operand2 !~ /\As*\z/) ) {

    (my $op1=$operand1)=~ s/^\s+//;    
    (my $op2=$operand2)=~ s/^\s+//;
     $op1=~ s/\s+$//;
     $op2=~ s/\s+$//;
     if(($op1 =~ m%\A($Y|$YM)\z%) && ($op2 =~ m%\A$NUM\z%) ) {
       $rb1->m_configure(-state=>'normal');
       $rb2->m_configure(-state=>'normal');
       $rb3->m_configure(-state=>'normal');
       $rb4->m_configure(-state=>'normal');
       $operator="";
      } elsif(($op1 =~ m%\A$YMD\z%) && ($op2 =~ m%\A$NUM\z%) ) {
       $rb1->m_configure(-state=>'normal');
       $rb2->m_configure(-state=>'normal');
       $rb3->m_configure(-state=>'normal');
       $rb4->m_configure(-state=>'normal');
       $rb5->m_configure(-state=>'normal');
       $rb6->m_configure(-state=>'normal');    
       $operator="";   
      } else {
       &disall;
      };
    } else {
       &disall;
    };
   }

 sub disall {
  $operator="";
  $rb1->m_configure(-state=>'disabled');
  $rb2->m_configure(-state=>'disabled');
  $rb3->m_configure(-state=>'disabled');
  $rb4->m_configure(-state=>'disabled'); 
  $rb5->m_configure(-state=>'disabled');
  $rb6->m_configure(-state=>'disabled');
   }

#################################################
#   start
#################################################
  
Tkx::MainLoop();

######################################
# subroutines                        #
######################################

####### help window #######
sub help {
 my $help=$top->new_toplevel();
 $help->g_wm_title('指定方法');
 $help->g_wm_attributes(-toolwindow=>1);
# $help->grab;
 
 my $text=$help->new_label(-text=>"
OP1:yy\t\t\t=>和暦・西暦相互変換
OP1:yy\tOP2:yy\t=>OP1からOP2までの年数
OP1:yy/mm\tOP2:yy/mm\t=>OP1からOP2までの月数
OP1:yy\t\tOP2:n\t=>OP1（以前｜前｜後｜以後）n年はいつ
\t\t（この場合のみnは４桁不可）
OP1:yy/mm\tOP2:n\t=>OP1（以前｜前｜後｜以後）n月はいつ
OP1:yy/mm/dd\tOP2:n\t=>OP1（以前｜前｜後｜以後）n日はいつ
OP1:yy/mm/dd\tOP2:n\t=>OP1にOP2歳に到達,誕生日はいつ
OP1:yy/mm/dd\tOP2:n\t=>OP1においてOP2歳である、誕生日はいつ
OP1:n\tOP2:yy/mm/dd\t=>OP2が誕生日の時OP1歳に達するのはいつ
OP1:yy/mm/dd\tOP2:yy/mm/dd\t=>
\tOP1<OP2:OP1からOP2までの日数
\tOP1>OP2:OP2が誕生日の時OP1で何歳

日付の表現　yy,yy/mm,yy/mm/dd
yy:【年】明治６年（１８７３年）以降のみ有効
　西暦：数字４桁
　和暦：アルファベット１文字（m,t,s,h,r)に数字１桁以上
mm:【月】１桁か２桁の数字
dd:【日】１桁か２桁の数字
（例）2021/6/15, r3/6/15,r3,r3/6

",
 -anchor=>'w',-justify=>'left');

 my $quitb=$help->new_button(-text=>'OK',-width=>5, -command=>sub {g_destroy $help;});

 $text->g_pack(-side=>'top');
 $quitb->g_pack(-side=>'top',-anchor=>'e',-padx=>4,-pady=>2);

 }


####### clear all text #######

sub clear {
 $operand1="";
 $operand2="";
 $result="";
 disall();
 
 }

####### date calculation ######

sub calc {

 if($operand1 !~ /\As*\z/) {
    (my $op1=$operand1)=~ s/^\s+//;    
    (my $op2=$operand2)=~ s/^\s+//;
     $op1=~ s/\s+$//;
     $op2=~ s/\s+$//;

     my ($y1,$ym1,$ymd1,$num1,$y2,$ym2,$ymd2,$num2,$blank2) =(0,0,0,0,0,0,0,0,0);


   if($op1 =~m%\A($NUM)\z%) {
     $num1=1
    };
   if($op1 =~m%\A($Y)\z%) {
     $num1=0;
     $y1=1;
    } elsif($op1 =~m%\A($YM)\z% ) {
     $ym1=1;
    } elsif($op1 =~m%\A($YMD)\z% ) {
     $ymd1=1;
    };

   if($op2 =~m%\A($NUM)\z%) {
     $num2=1
    };
   if($op2 eq "") {
      $blank2=1;
    } elsif($op2 =~m%\A($Y)\z%) {
      $y2=1;
      $num2=0;
    } elsif($op2 =~m%\A($YM)\z% ) {
      $ym2=1;
    } elsif($op2 =~m%\A($YMD)\z% ) {
      $ymd2=1;
    };


#print $y1,$ym1,$ymd1,$num1,$y2,$ym2,$ymd2,$num2,$blank2,"\n";
### 和暦・西暦変換
   if($y1 && $blank2) {
      if(my $date1=Date->new($op1)) {
      $date1->convertYear;
      $result=$date1->printDate;
       } else {
      $result="日付が不正です";
       };
      return; }

### 年数計算
   elsif($y1 && $y2) {
      if((my $date1=Date->new($op1)) &&
         (my $date2=Date->new($op2)) ) {
          my $ys=countYear($date1,$date2);
         if($ys) {
          $result=sprintf("%d 年",$ys);
          } else {
          $result="入力が不正です";
         };
       } else {
          $result="日付が不正です";
       };  
      return;
       }


### 月数計算
   elsif($ym1 && $ym2) {
      if((my $date1=Date->new($op1)) &&
         (my $date2=Date->new($op2)) ) {
          my $ms=countMonth($date1,$date2);
         if($ms) {
          $result=sprintf("%d か月",$ms);
          } else {
          $result="入力が不正です";
         };
       } else {
          $result="日付が不正です";
       };  
      return;
       }

### 年、月の前後計算
   elsif(($y1||$ym1) && $num2) {
     if($operator) {
       if(my $date=Date->new($op1)) {
         my $sw=(($operator eq "=+") || ($operator eq "=-") ) ? 1:0;
         if($y1) {
          if(($operator eq "+" ) || ($operator eq "=+")) {
            $date->afterYears($op2,$sw);
           } else {
             $date->beforeYears($op2,$sw);  
           };
          } else {
           if(($operator eq "+" ) || ($operator eq "=+")) {
             $date->afterMonths($op2,$sw);
            } else {
              $date->beforeMonths($op2,$sw);  
            };          
           };
          $result=$date->printDate; 
         } else {
         $result="日付が不正です";
         };
        } else {
         $result="ラジオボタンを選んでください";
       };
       return;
     }

### 日の前後計算、誕生日計算
   elsif($ymd1 && $num2) {
      if($operator) {
       if(my $date=Date->new($op1)) {
         my $sw=(($operator eq "=+") || ($operator eq "=-") ) ? 1:0;
         if(($operator eq "+" ) || ($operator eq "=+")) {
            $date->afterDays($op2,$sw);
            $result=$date->printDate;
          } elsif (($operator eq "-" ) || ($operator eq "=-")) {
            $date->beforeDays($op2,$sw);  
            $result=$date->printDate;
          } elsif ($operator eq "reach") {
            $date->beforeYears($op2);
            $date->afterDays;
            $result="誕生日は ".($date->printDate)." です";
          } else {
            $date->beforeYears($op2);
            $date->afterDays;
            my $date1=Date->new($date);
            $date1->beforeYears;
            $date1->afterDays;
            $result="誕生日は ".($date1->printDate)." と ".($date->printDate)." の間です";
            };
          } else {
          $result="日付が不正です";
          };
        } else {
         $result="ラジオボタンを選んでください";
       };
       return;
       }
### 年齢計算または日数計算
     elsif ($ymd1 && $ymd2) {
      if(( my $date2=Date->new($op1)) &&
         ( my $date1=Date->new($op2)) ) {
#     日数計算
          my $ds=countDay($date2,$date1);
        if($ds) {
          $result=sprintf("%d 日",$ds);
         } else {
#     年齢計算
          my ($y,$m)=getAge($date1,$date2,1);
          if(defined($y)) {
            $result=sprintf("%d 歳 %d か月です",$y,$m);
           } else {
            $result="入力が間違っています。誕生日がop2です。"; 
           };
          };
        } else {
         $result="日付が不正です";
        };
      return;
       }
     elsif ($num1 && $ymd2) {
       if( my $date=Date->new($op2) ) {
         $date->afterYears($op1);
         $date->beforeDays;
         $result=($date->printDate)." に ".$op1." 歳になります";
        } else {
          $result="日付が不正です";
        };
       return;
        }
     else {
       $result="入力が間違っています"; 
     };
    };
   }

 1;





